#ifndef __glfuncs_public
#define __glfuncs_public
#ifdef USE_OPENGL

#include <GL/gl.h>
#include <GL/glu.h>

typedef struct glimage_s glimage_t;

#define NO_INDEXED_COLOR

//extern GLuint screenbuffertextures[48];	/* 48 small textures. */
//extern int screenbufferwidth;
//extern int screenbufferheight;
extern GLint fullfilter;
extern int partialfilter;
extern int colourformat;
extern int screenwidth;
extern int screenheight;
extern unsigned char *screenbuffer;
#ifdef NO_INDEXED_COLOR
extern unsigned char *screenbuffer32;
extern unsigned char ipalr[256],ipalg[256],ipalb[256];
#endif
extern int lookangle;
extern int glscreenw;
extern int glscreenh;
//extern double screenratio;
//extern double screenxangle;
extern unsigned char savegamescreen[16000];
extern char* GLPath;

// GLAddScreenShape flags
#define GLSS_USELIGHT 1
#define GLSS_CORRECTRATIO 2
#define GLSS_OVERLAY 4

#ifdef NO_INDEXED_COLOR
void ConvertPartialOverlay(int sx, int sy, int w, int h);
#endif

void checkGLStatus (void);
void UploadOverlay (void);
void ShowPartialOverlay (int x, int y, int w, int h);
void GLRefresh (void);
void GLInit (void);
void GLRotateScreen (int cx, int cy, int angle, int scale);
void GLCalcVisibleThings ();
void GLStartRotate ();
void GLStopRotate ();
void GLSetScreenVisible (int vis);
void GLSetUpload(int upl);
void GLSetLightLevel (int fog, int darkness);
void GLSetLightRate (int rate);
void GLSetFadeFactor (int red, int green, int blue, int alpha);
int GLGetFadeAlpha ();
void GLDoFalling ();
void GLCacheLump(int lump);
void TimeRefresh(int rotate);

//void GLSaveScreen();
void GLSaveScreen(int fixratio);

extern char* gl_ss_ext;
int GLWriteSavedScreen(const char* name);
int GLWriteSaveGameScreen(const char* name);

glimage_t* GLLoadImage(const char* name, int mipmaps);
glimage_t* GLReloadImage(glimage_t* ret,const char* name, int mipmaps);
void GLFreeImage(glimage_t* img);

void GLClearScreenShapes();
void GLAddScreenShape(int lump, int x, int y, int flags);
void GLAddScreenShapeIntro(int lump, int x, int y, double rotate, double scale, double flags) ;
void GLAddScreenShapeEx(int lump, int x, int y, int rtx, int rty, double rotate, double scale, int flags);
void GLAddImage(glimage_t* img, int x, int y, int w, int h, int flags);
void GLAddImageEx(glimage_t* img, int x, int y, int w, int h, int rtx, int rty, double rotate, double scale, int flags);

void WriteDebug (char *error, int i,...);


#endif
#endif
