

/******************************************************************************
 
 Rain.h

 Copyright  2006, Birger N. Andreasen 
 Please send any bugreports, comments and other issues to:
 E-Mail = bna@post10.tele.dk
 Homepage with other ROTT stuff = http://home14.inet.tele.dk/Bna-Info
/******************************************************************************/


#define NUMDROPS 3500

typedef struct
{
	float xt,yt,zt;   //top vertex of the line
	float xb,yb,zb;   //bottom vertex of the line
	float xv,yv,zv;   //velocity of the drop
	int   splashstate;//what splashstate is drop in
	float alpha;      //alpha info
} DROP;

typedef struct
{
	int   tilex;      //x tile pos where rain start  (0 - 128(124)
	int   tiley;	  //y tile pos where rain start  (0 - 128(124)
	int   x,y,z;      //dimensions of the rain box
	float dtr,dtg,dtb;//top start color of drop 
	float dbr,dbg,dbb;//bottom end color of drop 
	float dropwidth;  //dropwidth
	float droplength; //droplength
	float xg,yg,zg;   // forces in the three axis (gravity,wind)
	float fade;		
	DROP *drops;      //array of drops
} RAIN;





